#ifndef SETTINGSDIALOG_H
#define SETTINGSDIALOG_H
#include "Tools/ButtonXP.h"
#include "Tools/MenuXP.h"
#include "SettingsDialogGeneral.h"
#include "SettingsDialogMouseClicks.h"
#include "SettingsDialogApparence.h"
#include "SettingsDialogApparenceTooltip.h"
#include "SettingsDialogInput.h"
#include "SettingsDialogOutput.h"
#include "SettingsDialogGen.h"
#include "TreePropSheet/TreePropSheet.h"
#include "wa_ipc.h"

/////////////////////////////////////////////////////////////////////////////
// CSettingsDialog dialog

class CSettingsDialog : public CDialog
{
	DECLARE_DYNAMIC(CSettingsDialog)
	// Construction
public:
	CSettingsDialog(UINT id, CWnd* pParent = NULL);   // standard constructor
	CSettingsDialog* getInstance(UINT id, CWnd* pParent = NULL);
	~CSettingsDialog();
	virtual BOOL DestroyWindow();

	// Dialog Data
	enum
	{
		IDD = IDD_SETTINGS
	};

	CButtonXP m_BtnOk;
	CButtonXP m_BtnCancel;

	TreePropSheet::CTreePropSheet m_TabSetting;
	CPtrArray listPropertyPage;
	CSettingsDialogGeneral m_SettingsDialogGeneral;
	CSettingsDialogMouseClicks m_SettingsDialogMouseClicks;
	CSettingsDialogInput m_SettingsDialogInput;
	CSettingsDialogOutput m_SettingsDialogOutput;
	CSettingsDialogGen m_SettingsDialogGen;
	CSettingsDialogApparence m_SettingsDialogApparence;
	CSettingsDialogApparenceTooltip m_SettingsDialogApparenceTooltip;
	void SetActivePage(int index);
	void SetActivePage(prefsDlgRec* iPrefs);

	// Overrides
protected:
	virtual void DoDataExchange(CDataExchange* pDX);  // DDX/DDV support
	// Implementation
protected:
	afx_msg void OnCreate(LPCREATESTRUCT lpCreateStruct);
	virtual BOOL OnInitDialog();
	virtual void OnOK();
	virtual void OnCancel();
	DECLARE_MESSAGE_MAP()
		DECLARE_MENUXP()
};
#endif