#include "../stdafx.h"
#include "../MainHelper.h"
#include "../Resource.h"
#include "resource.h"
#include "common.h"
#include "args.h"
#include "frame.h"
#include "player.h"
#include "helper.h"
#include "stream.h"
#include <stdio.h>
#include <process.h>
#include "StreamManager.h"
#include "DllInput.h"
#include "StandardInput.h"
#include "../Out/Out.h"
#include "../volume.h"
#include "StandardInputConfig.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

TCHAR inDescription[50] = _T("Module standard redvelopper par Mickal SEBIRE");

HANDLE StopEvent;

bool ThreadSync, UserBreak;


HANDLE ThreadQueueEvent = NULL;
HANDLE FinishEvent;
int NewSeekPosition;

int BuffersType;
int InputBuffersType;
int ForceMono;
int Downsampling;
int Priority;

extern char* pcm_sample;
extern int pcm_point;
extern Helper m_HelperIn;

MPArgs Args;
Frame fr;

DWORD PlayerThreadID;
HANDLE PlayThreadHan;

extern In_Module standardIn;

extern CStandardInputConfig* StandardInputConfig;

int infoBitrate;
int infoSamplerate;
int infoStereo; 
int infoSynched;

__inline void AudioFlush()
{
	try {
		if (pcm_point)
		{
			if (!UserBreak)
			{
				char* ppcm_sample = pcm_sample;
				do
				{
					while (standardIn.outMod->CanWrite() < 8192 && !UserBreak)
						Sleep(77);
					if (pcm_point > 8192)
					{
						standardIn.outMod->Write(ppcm_sample, 8192);
						ppcm_sample += 8192;
					}
					else if (pcm_point == 8192)
					{
						standardIn.outMod->Write(ppcm_sample, pcm_point);
					}
					else
					{
						standardIn.outMod->Write(ppcm_sample, pcm_point);
					}
					pcm_point -= 8192;
				}
				while (pcm_point > 0);
			}
			pcm_point = 0;
		}
	} catch(...) 
	{
	}
}
void HardAudioReset()
{
	//TRACE(_T("HardAudioReset\n"));
	standardIn.outMod->Close();
	standardIn.outMod->Open(Args.SampleRate, Args.Channels, Args.AudioBits, 0, 0);
}

unsigned long __stdcall PlayThread(void*)
{
	SynthesisFilterInit();
	try
	{
		//Init du dcodeur
		Init_MPEGDecoder(Args.DownSample);
	}
	catch (...)
	{
		SetEvent(ThreadQueueEvent);
		SetEvent(FinishEvent);
		ExitThread(0);
	}

	UserBreak = false;
	try
	{
		if (standardIn.outMod->Open(Args.SampleRate, Args.Channels, Args.AudioBits, 0, 0) < 0)
			throw 1;
	}
	catch (...)
	{
		Done_MPEGDecoder();
		SetEvent(ThreadQueueEvent);
		SetEvent(FinishEvent);
		AfxMessageBox(m_HelperIn.MyLoadString(IDS_FAILED_INIT_OUTPUT), MB_ICONEXCLAMATION | MB_OK);
		ExitThread(0);
	}

	if (!InitInputBuffer())
	{
		FreeInputBuffer();
		Done_MPEGDecoder();
		standardIn.outMod->Close();
		SetEvent(ThreadQueueEvent);
		SetEvent(FinishEvent);
		ExitThread(0);
	}
	NewSeekPosition = -1;
	SetEvent(ThreadQueueEvent);

	long NewSF;
	bool Res;

	for (; ;)
	{
		if (NewSeekPosition != -1)
		{
			standardIn.outMod->Flush(NewSeekPosition - Args.CurrentPosMs + standardIn.outMod->GetOutputTime());
			Args.CurrentPosMs = NewSeekPosition;
			if (Seek_Stream(NewSeekPosition))
				NewSeekPosition = -1;
			else
				NewSeekPosition = 0;
		}
		FillInputBuffer();

		Res = GetNextFrame();

		if (UserBreak || !Res)
			break;

		Args.CurrentPos++;
		Args.CurrentPosMs += Frame2ms();

		NewSF = freqs[fr.sampling_frequency] / (Args.DownSample == 2 ? 4 : Args.DownSample == 1 ? 2 : 1);

		if (Args.SampleRate != NewSF)
		{
			Args.SampleRate = NewSF;
			HardAudioReset();
		}

		if (fr.error_protection)
			GetBits(16);	 
		if (fr.lay == 3)
			Do_Layer3();
		else if (fr.lay == 2)
			Do_Layer2();
		else if (fr.lay == 1)
			Do_Layer1();
		if (Args.PauseFlag)
		{
			standardIn.outMod->Pause(1);
			ThreadSync = 1;  
			while (Args.PauseFlag)
				Sleep(77);
			if (!UserBreak)
				standardIn.outMod->Pause(0);
		}
	}
	FreeInputBuffer();
	AudioFlush();
	if (Decoder_Initialized)
	{
		Done_MPEGDecoder();
		Decoder_Initialized = false;
	}
	standardIn.outMod->Close();
	if (!UserBreak)
		PostMessage(standardIn.hMainWindow, WM_PLAYOVER, 0, 0);
	UserBreak = false; 
	SetEvent(FinishEvent);
	ExitThread(0);
	return 0;
}

void SynthesisFilterInit()
{
	typedef int (*func)(real*, int, char*, int*);
	typedef int (*func_mono)(real*, char*, int*);

	static func funcs[3] =
	{
		synth_1to1, synth_2to1, synth_4to1
	};

	static func_mono funcs_mono[2][3] =
	{
		{     synth_1to1_mono2stereo ,
		synth_2to1_mono2stereo ,
		synth_4to1_mono2stereo ,
		}, {   synth_1to1_mono ,
		synth_2to1_mono ,
		synth_4to1_mono
		}
	};

	fr.synth = (synthProc)funcs[Args.DownSample];
	fr.synth_mono = funcs_mono[Args.ForceMono][Args.DownSample];

	fr.block_size = 128 >> (Args.ForceMono + Args.DownSample);
}

void Quit()
{
	//TRACE(_T("Quit\n"));
	CloseHandle(FinishEvent);
	FinishEvent = NULL;
}

void InputInit()
{
	//TRACE(_T("InputInit\n"));
	Downsampling = (int)::GetProfileInt(_T("StandardInput"), _T("Downsampling"), 0);
	ForceMono = (int)::GetProfileInt(_T("StandardInput"), _T("ForceMono"), 0);
	Priority = (int)::GetProfileInt(_T("StandardInput"), _T("Priority"), 3);
	FinishEvent = CreateEvent(NULL, false, false, NULL);

	UserBreak = false;
	fr.single = -1;   

	for (int i = 0; i < 32; i++)
		Args.equalizer[i] = 1.0;
}
bool CanSetPos()
{
	//TRACE(_T("CanSetPos\n"));
	//return in->isSeekable() == 1;
	return true;
}

void Close()
{
	//TRACE(_T("Close\n"));
	UserBreak = true;
	Args.PauseFlag = false;
	if (PlayThreadHan != NULL)
	{
		WaitForSingleObject(FinishEvent, INFINITE);
		CloseHandle(PlayThreadHan);
		PlayThreadHan = NULL;
	}
	if (StreamInit)
	{
		Done_Stream();
		StreamInit = false;
	}
}

int GetPos()
{
	//TRACE(_T("GetPos\n"));
	return Currentms();
}

int GetSize()
{
	//TRACE(_T("GetSize\n"));
	return Totalms();
}

bool InitStream()
{
	//TRACE(_T("InitStream\n"));
	Args.PauseFlag = false;
	try
	{
		Init_Stream();
	}
	catch (...)
	{
		return false;
	}

	try
	{
		if (!ReadFrame(&fr))
		{
			Done_Stream();
			return false;
		}
		Reset_Stream();
	}
	catch (...)
	{
		Done_Stream();
		return false;
	}
	return true;
}

void Pause()
{
	//TRACE(_T("Pause\n"));
	Args.PauseFlag = true;
}

int Play(TCHAR* FileName)
{
	//TRACE(_T("Play\n"));
	switch (BuffersType)
	{
	case 0:
		Args.Buffers = 1;
		Args.BufferSize = 16384;
		break;
	case 1:
		Args.Buffers = 4;
		Args.BufferSize = 16384;
		break;
	case 2:
		Args.Buffers = 8;
		Args.BufferSize = 16384;
		break;
	case 3:
		Args.Buffers = 8;
		Args.BufferSize = 32768;
		break;
	case 4:
		Args.Buffers = 10;
		Args.BufferSize = 32768;
		break;
	}

	switch (InputBuffersType)
	{
	case 0:
		Args.InpBufFrames = 10;
		break;
	case 1:
		Args.InpBufFrames = 50;
		break;
	case 2:
		Args.InpBufFrames = 100;
		break;
	case 3:
		Args.InpBufFrames = 150;
		break;
	case 4:
		Args.InpBufFrames = 200;
		break;
	}

	Args.ForceMono = ForceMono;
	Args.DownSample = Downsampling;

	Args.SampleRate = freqs[fr.sampling_frequency];

	Args.Channels = 2;

	if (Args.ForceMono)
	{
		if (fr.single < 0)
			fr.single = 3;
		Args.Channels = 1;
	}

	if (Args.DownSample == 1)
		Args.SampleRate = Args.SampleRate / 2;
	if (Args.DownSample == 2)
		Args.SampleRate = Args.SampleRate / 4;

	StreamManager* sManager = Args.getStreamManager();
	sManager->SetInName(FileName);
	if (!InitStream())
		return -1;

	ThreadQueueEvent = CreateEvent(NULL, false, false, NULL);
	if (!ThreadQueueEvent)
		return -1;
	ResetEvent(FinishEvent);
	if (PlayThreadHan)
	{
		CloseHandle(PlayThreadHan);
		PlayThreadHan = NULL;
	}
	PlayThreadHan = CreateThread(NULL, 0, PlayThread, 0, 0, &PlayerThreadID);
	if (!PlayThreadHan)
		return -1;
	switch (Priority)
	{
	case 1:
		SetThreadPriority(PlayThreadHan, THREAD_PRIORITY_LOWEST);
		break;
	case 2:
		SetThreadPriority(PlayThreadHan, THREAD_PRIORITY_BELOW_NORMAL);
		break;
	case 3:
		SetThreadPriority(PlayThreadHan, THREAD_PRIORITY_NORMAL);
		break;
	case 4:
		SetThreadPriority(PlayThreadHan, THREAD_PRIORITY_ABOVE_NORMAL);
		break;
	case 5:
		SetThreadPriority(PlayThreadHan, THREAD_PRIORITY_HIGHEST);
		break;
	}

	WaitForSingleObject(ThreadQueueEvent, INFINITE);
	CloseHandle(ThreadQueueEvent);
	ThreadQueueEvent = NULL;

	NewSeekPosition = -1;

	if (IsPaused())
		Done_Stream();
	return 0;
}

void Resume()
{
	//TRACE(_T("Resume\n"));
	Args.PauseFlag = false;
}

void SetPos(int posInMs)
{
	//TRACE(_T("SetPos\n"));
	if (posInMs < 0)
		posInMs = 0;
	NewSeekPosition = posInMs;
}

void SetWindow(HWND Wnd)
{
	//TRACE(_T("SetWindow\n"));
	Args.wnd = Wnd;
}

void InputConfig(HWND hwndParent)
{
	//TRACE(_T("InputConfig\n"));
	StandardInputConfig = StandardInputConfig->getInstance(IDD_STANDARD_INPUT_CONFIG, CWnd::FromHandle(standardIn.hMainWindow));
	StandardInputConfig->DoModal();
	delete StandardInputConfig;
	StandardInputConfig = NULL;
}

void InputAbout(HWND hwndParent)
{
	//TRACE(_T("InputAbout\n"));
	CString message(inDescription);
	AfxMessageBox(message, MB_ICONINFORMATION | MB_OK);
}

void GetFileInfo(TCHAR* file, TCHAR* title, int* length_in_ms)
{
	*length_in_ms = 0;
	title[0] = 0;
}

int InfoBox(TCHAR* file, HWND hwndParent)
{
	//TRACE(_T("InfoBox\n"));
	return 0;
}

int IsOurFile(TCHAR* fn)
{
	//TRACE(_T("IsOurFile\n"));
	if (_tcsstr(fn, _T("http://")) == fn)
		return 1;
	return 0;
}

int IsPaused()
{
	//TRACE(_T("IsPaused\n"));
	if (Args.PauseFlag)
		return 1;
	return 0;
}

void SetVolume(int volume)
{
	//TRACE(_T("SetVolume\n"));
	standardIn.outMod->SetVolume(volume);
}

void InputSetPan(int pan)
{
	//TRACE(_T("InputSetPan\n"));
	standardIn.outMod->SetPan(pan);
}

void SAVSAInit(int maxlatency_in_ms, int srate)
{
	//TRACE(_T("SASAInit\n"));
}


void SAVSADeInit()
{
	//TRACE(_T("SAVSADeInit\n"));
}


void SAAddPCMData(void* PCMData, int nch, int bps, int timestamp)
{
	//TRACE(_T("SAAddPCMData\n"));
}


int SAGetMode()
{
	//TRACE(_T("SAGetMode\n"));
	return 0;
}


void SAAdd(void* data, int timestamp, int csa)
{
	//TRACE(_T("SAAdd\n"));
}


void VSAAddPCMData(void* PCMData, int nch, int bps, int timestamp)
{
	//TRACE(_T("VSAAddPCMDatA\n"));
}


int VSAGetMode(int* specNch, int* waveNch)
{
	return 0;
}


void VSAAdd(void* data, int timestamp)
{
	//TRACE(_T("VSAAdd\n"));
}


void VSASetInfo(int nch, int srate)
{
	//TRACE(_T("VSASetInfo\n"));
}


int dsp_isactive()
{
	//TRACE(_T("dsp_isactive\n"));
	return Args.UseEqualizer ? 1 : 0;
}


int dsp_dosamples(short int* samples, int numsamples, int bps, int nch, int srate)
{
	//TRACE(_T("dsp_dosamples numsamples %d bps %d nch %d srate %d\n"),numsamples, bps, nch, srate);
	//	for(int i = 0; i < numsamples; i++)
	//		samples[i] *= (equalizer[i%(bps * nch)] / 10);
	return numsamples;
}
void EQSet(int on, TCHAR data[10], int preamp)
{
	//TRACE(_T("EQSet\n"));
}

void SetInfo(int bitrate, int srate, int stereo, int synched)
{
	//TRACE(_T("SetInfo %d %d %d %d\n"), bitrate, srate, stereo, synched);
	infoBitrate = bitrate;
	infoSamplerate = srate;
	infoStereo = stereo; 
	infoSynched = synched;
}


