// StandardInputConfig.cpp : fichier d'implmentation
//

#include "../stdafx.h"
#include "resource.h"   	// main symbols
#include "StandardInputConfig.h"
#include "../MainHelper.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

Helper m_HelperIn;

extern int BuffersType;
extern int InputBuffersType;
extern int ForceMono;
extern int Downsampling;
extern int Priority;

// Bote de dialogue CStandardInputConfig

CStandardInputConfig* StandardInputConfig = NULL;

IMPLEMENT_DYNAMIC(CStandardInputConfig, CDialog)

CStandardInputConfig::CStandardInputConfig(UINT id, CWnd * pParent) : CDialog(id, pParent)
{
	Downsampling = (int)::GetProfileInt(_T("StandardInput"), _T("Downsampling"), 0);
	ForceMono = (int)::GetProfileInt(_T("StandardInput"), _T("ForceMono"), 0);
	Priority = (int)::GetProfileInt(_T("StandardInput"), _T("Priority"), 3);

	m_forcemono = (ForceMono == 1);

	m_ds12 = (Downsampling == 1);
	m_ds14 = (Downsampling == 2);
}

CStandardInputConfig::~CStandardInputConfig()
{
}

CStandardInputConfig* CStandardInputConfig::getInstance(UINT id, CWnd* pParent)
{
	if (StandardInputConfig != NULL && StandardInputConfig->m_hWnd != NULL)
		StandardInputConfig->DestroyWindow();
	if (StandardInputConfig != NULL && StandardInputConfig->m_hWnd == NULL)
	{
		delete StandardInputConfig;
		StandardInputConfig = NULL;
	}
	if (StandardInputConfig == NULL)
		StandardInputConfig = new CStandardInputConfig(id, pParent);
	else
		StandardInputConfig->CloseWindow();
	return StandardInputConfig;
}

void CStandardInputConfig::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	CMenuXP::SetXPLookNFeel(this, CMenuXP::GetXPLookNFeel(this->GetParent()));
	DDX_Control(pDX, IDC_IBUFFERS, m_ibuffers);
	DDX_Control(pDX, IDC_BUFFERS, m_buffers);
	DDX_Control(pDX, IDC_PRIORITY, m_priority);
	DDX_Check(pDX, IDC_MONO, m_forcemono);
	DDX_Check(pDX, IDC_DS12, m_ds12);
	DDX_Check(pDX, IDC_DS14, m_ds14);
	DDX_Control(pDX, IDOK, m_BtnOk);
	DDX_Control(pDX, IDCANCEL, m_BtnCancel);
}

void CStandardInputConfig::OnDs12()
{
	((CButton *)GetDlgItem(IDC_DS14))->SetCheck(0);
}

void CStandardInputConfig::OnDs14()
{
	((CButton *)GetDlgItem(IDC_DS12))->SetCheck(0);
}

BOOL CStandardInputConfig::OnInitDialog()
{
	CDialog::OnInitDialog();

	m_HelperIn.translateDlgItemText(this, IDC_LPRIORITY);
	m_HelperIn.translateDlgItemText(this, IDC_LINPUTBUFFER);
	m_HelperIn.translateDlgItemText(this, IDC_LOUPUTBUFFER);
	m_HelperIn.translateDlgItemText(this, IDC_DS12);
	m_HelperIn.translateDlgItemText(this, IDC_DS14);
	m_HelperIn.translateDlgItemText(this, IDC_MONO);

	m_buffers.SetRange(0, 4);
	m_buffers.SetLineSize(1);
	m_buffers.SetPageSize(1);
	m_buffers.SetPos(BuffersType);

	m_ibuffers.SetRange(0, 4);
	m_ibuffers.SetLineSize(1);
	m_ibuffers.SetPageSize(1);
	m_ibuffers.SetPos(InputBuffersType);

	m_priority.SetRange(0, 4);
	m_priority.SetLineSize(1);
	m_priority.SetPageSize(1);
	m_priority.SetPos(Priority - 1);
	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}

void CStandardInputConfig::OnOK()
{
	UpdateData(TRUE);
	ForceMono = m_forcemono ? 1 : 0;

	Downsampling = m_ds12 ? 1 : (m_ds14 ? 2 : 0);

	BuffersType = m_buffers.GetPos();

	InputBuffersType = m_ibuffers.GetPos();

	Priority = m_priority.GetPos() + 1;
	AfxGetApp()->WriteProfileInt(_T("StandardInput"), _T("Downsampling"), Downsampling);
	AfxGetApp()->WriteProfileInt(_T("StandardInput"), _T("ForceMono"), ForceMono);
	AfxGetApp()->WriteProfileInt(_T("StandardInput"), _T("Priority"), Priority);
	CDialog::OnOK();
}

IMPLEMENT_MENUXP(CStandardInputConfig, CDialog);

BEGIN_MESSAGE_MAP(CStandardInputConfig, CDialog)
  ON_BN_CLICKED(IDC_DS12, OnDs12)
  ON_BN_CLICKED(IDC_DS14, OnDs14)
  ON_MENUXP_MESSAGES()
END_MESSAGE_MAP()
